#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <i86.h>
//#include <process.h>

#include "..\extdlc.c"

#include "drvdef.c"

#include "drvstrc.c"

void putstr(unsigned char *string);

unsigned dosexec(char __far *path, char *arg);
void restore_videomode(void);
extern void __far (*driver_videomode)(void);

struct driver *drivers;

extern char *message;

unsigned driver_count = 0;

extern int videodriver;

/*unsigned char device_exists(unsigned driver, unsigned device)
{
  if(device < drivers[driver].dev_count)
    return 1;
  return 0;
}*/

int driver_id(char *name)
{
  int n = driver_count;

  while(n--)
  {
    if(!strcmp(drivers[n].dev_name, name))
      break;
  }

  return n;
}

int __far (*driver_func_ptr)();

int call_cmd_func_devnum(unsigned device, void __far *cmd, unsigned func_seg);
#pragma aux call_cmd_func_devnum = \
  "call dword ptr es:driver_func_ptr" \
  parm [bx] [dx ax] [es] value [ax];
int call_cmd_func_sdev(void __far *cmd, unsigned func_seg);
#pragma aux call_cmd_func_sdev = \
  "call dword ptr es:driver_func_ptr" \
  parm [dx ax] [es] value [ax];  
int dev_cmd(unsigned driver, int device, void __far *cmd)
{
  if(drivers[driver].cmd_func)
  {
    driver_func_ptr = drivers[driver].cmd_func;    
    if(drivers[driver].dev_count >= 1)
//      return (*drivers[driver].cmd_func)(device, cmd);
      return call_cmd_func_devnum(device, cmd, FP_SEG(&driver_func_ptr));
    if(drivers[driver].dev_count == -1)      
//      return (*drivers[driver].cmd_func)(cmd);
      return call_cmd_func_sdev(cmd, FP_SEG(&driver_func_ptr));
  }
  return -1;
}

int call_read_func_devnum(unsigned device, unsigned func_seg, char *buff, unsigned count);
#pragma aux call_read_func_devnum = \
  "call dword ptr es:driver_func_ptr" \
  parm [ax] [es] [dx bx] [cx] value [ax];
int call_read_func_sdev(unsigned func_seg, char *buff, unsigned count);
#pragma aux call_read_func_sdev = \
  "call dword ptr es:driver_func_ptr" \
  parm [es] [dx bx] [cx] value [ax];  
//int dev_read(unsigned driver, int device)
int dev_read(unsigned driver, int device, char *buff, unsigned count)
{
  if(drivers[driver].read_func)
  {
    driver_func_ptr = drivers[driver].read_func;        
    if(drivers[driver].dev_count >= 1)    
      return call_read_func_devnum(device, FP_SEG(&driver_func_ptr), buff, count);
    if(drivers[driver].dev_count == -1)
      return call_read_func_sdev(FP_SEG(&driver_func_ptr), buff, count);
  }
  return -1;
}

int call_write_func_devnum(unsigned device, char *buff, unsigned count, unsigned func_seg);
#pragma aux call_write_func_devnum = \
  "call dword ptr es:driver_func_ptr" \
  parm [ax] [dx bx] [cx] [es] value [ax];
int call_write_func_sdev(char *buff, unsigned count, unsigned func_seg);
#pragma aux call_write_func_sdev = \
  "call dword ptr es:driver_func_ptr" \
  parm [dx bx] [cx] [es] value [ax];  
//int dev_write(unsigned driver, int device, unsigned char byte)
int dev_write(unsigned driver, int device, char *buff, unsigned count)
{
  if(drivers[driver].write_func)
  {
    driver_func_ptr = drivers[driver].write_func;            
    if(drivers[driver].dev_count >= 1)
      return call_write_func_devnum(device, buff, count, FP_SEG(&driver_func_ptr));
    if(drivers[driver].dev_count == -1)      
      return call_write_func_sdev(buff, count, FP_SEG(&driver_func_ptr));
  }
  return -1;
}

int call_open_func_devnum(int device, unsigned mode, unsigned func_seg);
#pragma aux call_open_func_devnum = \
  "call dword ptr es:driver_func_ptr" \
  parm [bx] [ax] [es] value [ax];
int call_open_func_sdev(unsigned mode, unsigned func_seg);
#pragma aux call_open_func_sdev = \
  "call dword ptr es:driver_func_ptr" \
  parm [ax] [es] value [ax];    
int dev_open(unsigned driver, int device, unsigned mode)
{
  if(drivers[driver].open_func)  
  {
//    sprintf(message, "%p", drivers[driver].open_func);
//    putstr(message);
    driver_func_ptr = drivers[driver].open_func;
    if(drivers[driver].dev_count >= 1)    
      return call_open_func_devnum(device, mode, FP_SEG(&driver_func_ptr));
    if(drivers[driver].dev_count == -1)      
      return call_open_func_sdev(mode, FP_SEG(&driver_func_ptr));
  }
  return -1;
}

int call_close_func_devnum(int device, unsigned func_seg);
#pragma aux call_close_func_devnum = \
  "call dword ptr es:driver_func_ptr" \
  parm [ax] [es] value [ax];
int call_close_func_sdev(unsigned func_seg);
#pragma aux call_close_func_sdev = \
  "call dword ptr es:driver_func_ptr" \
  parm [es] value [ax];
int dev_close(unsigned driver, int device)
{
  if(drivers[driver].close_func)
  {
    driver_func_ptr = drivers[driver].close_func;                    
    if(drivers[driver].dev_count >= 1)    
      return call_close_func_devnum(device, FP_SEG(&driver_func_ptr));
    if(drivers[driver].dev_count == -1)      
      return call_close_func_sdev(FP_SEG(&driver_func_ptr));
  }
  return -1;
}

int call_lseek_func_devnum(int device, int offset, unsigned func_seg);
#pragma aux call_lseek_func_devnum = \
  "call dword ptr es:driver_func_ptr" \
  parm [bx] [ax] [es] value [ax];
int call_lseek_func_sdev(int offset, unsigned func_seg);
#pragma aux call_lseek_func_sdev = \
  "call dword ptr es:driver_func_ptr" \
  parm [ax] [es] value [ax];  
int dev_lseek(unsigned driver, int device, int offset)
{
  if(drivers[driver].lseek_func)
  {
    driver_func_ptr = drivers[driver].lseek_func;                        
    if(drivers[driver].dev_count >= 1)    
//      return (*drivers[driver].lseek_func)(device, offset);
      return call_lseek_func_devnum(device, offset, FP_SEG(&driver_func_ptr));
    if(drivers[driver].dev_count == -1)      
//      return (*drivers[driver].lseek_func)(offset);
      return call_lseek_func_sdev(offset, FP_SEG(&driver_func_ptr));
  }
  return -1;
}

int call_fsync_func_devnum(int device, unsigned func_seg);
#pragma aux call_fsync_func_devnum =  \
  "call dword ptr es:driver_func_ptr" \
  parm [ax] [es] value [ax];
int call_fsync_func_sdev(unsigned func_seg);
#pragma aux call_fsync_func_sdev =  \
  "call dword ptr es:driver_func_ptr" \
  parm [es] value [ax];
int dev_fsync(unsigned driver, int device)
{
  if(drivers[driver].fsync_func)
  {
    driver_func_ptr = drivers[driver].fsync_func;                            
    if(drivers[driver].dev_count >= 1)    
      return call_fsync_func_devnum(device, FP_SEG(&driver_func_ptr));
    if(drivers[driver].dev_count == -1)      
      return call_fsync_func_sdev(FP_SEG(&driver_func_ptr));
  }
  return -1;
}

int call_error_func_devnum(int device, unsigned func_seg);
#pragma aux call_error_func_devnum = \
  "call dword ptr es:driver_func_ptr" \
  parm [ax] [es] value [ax];
int call_error_func_sdev(unsigned func_seg);
#pragma aux call_error_func_sdev = \
  "call dword ptr es:driver_func_ptr" \
  parm [es] value [ax];
int dev_geterror(unsigned driver, int device)
{
  if(drivers[driver].error_func)
  {
    driver_func_ptr = drivers[driver].error_func;
    if(drivers[driver].dev_count >= 1)
      return call_error_func_devnum(device, FP_SEG(&driver_func_ptr));
    if(drivers[driver].dev_count == -1)
      return call_error_func_sdev(FP_SEG(&driver_func_ptr));
  }
  return -1;
}

inline int unload_driver(unsigned driver)
{
  if(drivers[driver].unload_func)
  {
    drivers[driver].unload_func();
    return 0;
  }
  return 1;
}

int unload_module(char *modname)
{
  unsigned n = driver_count;
  int rc;

  while(n--)
  {
    if(!strcmp(drivers[n].dev_name, modname))
    {
      rc = unload_driver(n);
      driver_count--;
      
      for(;n < driver_count;n++)
        drivers[n] = drivers[n+1];

      return rc;
    }
  }
  return n;
}
 
void video_mode(unsigned char mode);
extern unsigned char video;
void draw_screen(void);

extern unsigned char _VIDEO_MODE;



unsigned short get_memory_allocation_strategy(void);
#pragma aux get_memory_allocation_strategy = \
"mov al, 0" \
"int 0x58" \
value [ ax ];

void set_memory_allocation_strategy(unsigned char strategy);
#pragma aux set_memory_allocation_strategy = \
"mov al, 1" \
"int 0x58" \
parm [ bx ];


void driver_installer();

int load_driver(char *program, char *modname)
{
  unsigned n = 0;
  unsigned old_driver_count = driver_count;
  char args[3];
  unsigned short memory_allocation_strategy = get_memory_allocation_strategy();
  // find free interrupt
  while(_dos_getvect(++n))
  {
    if(!n)
      return -1;
  }

  sprintf(args, "%X", n);
    
  _dos_setvect(n, driver_installer);
  set_memory_allocation_strategy(0x82);  
  dosexec(program, args);
  set_memory_allocation_strategy(memory_allocation_strategy);

//  if(_VIDEO_MODE != video)
//    restore_videomode();

  draw_screen();  
  _dos_setvect(n, 0);

  if(old_driver_count != driver_count)
  {
    strncpy(drivers[old_driver_count].dev_name, modname, 5);
    drivers[old_driver_count].dev_name[5] = 0;
  }

  return 0;
}
